Imports ZylSoft.Timers

Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call               
    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents lblIdleTime As System.Windows.Forms.Label
    Friend WithEvents btnStop As System.Windows.Forms.Button
    Friend WithEvents btnStart As System.Windows.Forms.Button
    Friend WithEvents textBoxOut As System.Windows.Forms.TextBox
    Friend WithEvents cmpIdleTimer As ZylSoft.Timers.IdleTimer
    Private WithEvents cmpApplicationIdleTimer As WinFormsApplicationIdleTimer
    Friend WithEvents radioButtonApplication As RadioButton
    Private WithEvents radioButtonSystem As RadioButton
    Friend WithEvents timerStandard As System.Windows.Forms.Timer

    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        components = New ComponentModel.Container()
        lblIdleTime = New Label()
        btnStop = New Button()
        btnStart = New Button()
        textBoxOut = New TextBox()
        timerStandard = New Timer(components)
        radioButtonApplication = New RadioButton()
        radioButtonSystem = New RadioButton()
        Me.cmpIdleTimer = New ZylSoft.Timers.IdleTimer(Me.components)
        Me.cmpApplicationIdleTimer = New ZylSoft.Timers.WinFormsApplicationIdleTimer(Me.components)
        SuspendLayout()
        ' 
        ' lblIdleTime
        ' 
        lblIdleTime.Anchor = AnchorStyles.Bottom Or AnchorStyles.Left
        lblIdleTime.AutoSize = True
        lblIdleTime.Location = New Point(17, 149)
        lblIdleTime.Name = "lblIdleTime"
        lblIdleTime.Size = New Size(61, 15)
        lblIdleTime.TabIndex = 7
        lblIdleTime.Text = "Idle Time: "
        ' 
        ' btnStop
        ' 
        btnStop.Anchor = AnchorStyles.Bottom
        btnStop.Location = New Point(114, 203)
        btnStop.Name = "btnStop"
        btnStop.Size = New Size(90, 29)
        btnStop.TabIndex = 6
        btnStop.Text = "Stop"
        ' 
        ' btnStart
        ' 
        btnStart.Anchor = AnchorStyles.Bottom
        btnStart.Location = New Point(114, 168)
        btnStart.Name = "btnStart"
        btnStart.Size = New Size(90, 28)
        btnStart.TabIndex = 5
        btnStart.Text = "Start"
        ' 
        ' textBoxOut
        ' 
        textBoxOut.Anchor = AnchorStyles.Top Or AnchorStyles.Bottom Or AnchorStyles.Left Or AnchorStyles.Right
        textBoxOut.Location = New Point(17, 15)
        textBoxOut.Multiline = True
        textBoxOut.Name = "textBoxOut"
        textBoxOut.ScrollBars = ScrollBars.Vertical
        textBoxOut.Size = New Size(259, 122)
        textBoxOut.TabIndex = 4
        ' 
        ' timerStandard
        ' 
        timerStandard.Interval = 200
        ' 
        ' radioButtonApplication
        ' 
        radioButtonApplication.AutoSize = True
        radioButtonApplication.Location = New Point(22, 203)
        radioButtonApplication.Name = "radioButtonApplication"
        radioButtonApplication.Size = New Size(86, 19)
        radioButtonApplication.TabIndex = 9
        radioButtonApplication.Text = "Application"
        radioButtonApplication.UseVisualStyleBackColor = True
        ' 
        ' radioButtonSystem
        ' 
        radioButtonSystem.AutoSize = True
        radioButtonSystem.Checked = True
        radioButtonSystem.Location = New Point(22, 178)
        radioButtonSystem.Name = "radioButtonSystem"
        radioButtonSystem.Size = New Size(63, 19)
        radioButtonSystem.TabIndex = 8
        radioButtonSystem.TabStop = True
        radioButtonSystem.Text = "System"
        radioButtonSystem.UseVisualStyleBackColor = True
        ' 
        ' Form1
        ' 
        AutoScaleBaseSize = New Size(6, 16)
        ClientSize = New Size(292, 238)
        Controls.Add(radioButtonApplication)
        Controls.Add(radioButtonSystem)
        Controls.Add(lblIdleTime)
        Controls.Add(btnStop)
        Controls.Add(btnStart)
        Controls.Add(textBoxOut)
        Name = "Form1"
        StartPosition = FormStartPosition.CenterScreen
        Text = "ZylIdleTimer.NET Demo"
        ResumeLayout(False)
        PerformLayout()

    End Sub

#End Region

    ' This delegate enables asynchronous calls for setting
    ' the text property on a TextBox control.
    Delegate Sub SetTextCallback(ByVal text As String)

    Private Sub Set_textBoxOutText(ByVal [text] As String)

        ' InvokeRequired required compares the thread ID of the
        ' calling thread to the thread ID of the creating thread.
        ' If these threads are different, it returns true.
        If Me.textBoxOut.InvokeRequired Then

            Dim d As New SetTextCallback(AddressOf Set_textBoxOutText)
            Me.Invoke(d, New Object() {[text]})

        Else
            Me.textBoxOut.Text = [text]
            Me.textBoxOut.SelectionStart = textBoxOut.Text.Length
            Me.textBoxOut.SelectionLength = 0
            Me.textBoxOut.ScrollToCaret()
        End If
    End Sub

    Private Sub btnStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStart.Click
        btnStop_Click(sender, e)
        timerStandard.Enabled = True
        If (radioButtonSystem.Checked) Then
            cmpIdleTimer.Enabled = True
            cmpApplicationIdleTimer.Enabled = False
        Else
            cmpApplicationIdleTimer.Enabled = True
            cmpIdleTimer.Enabled = False
        End If

        radioButtonSystem.Enabled = False
        radioButtonApplication.Enabled = False
    End Sub

    Private Sub btnStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStop.Click
        timerStandard.Enabled = False
        cmpIdleTimer.Enabled = False
        cmpApplicationIdleTimer.Enabled = False
        radioButtonSystem.Enabled = True
        radioButtonApplication.Enabled = True
    End Sub

    Private Sub timerStandard_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles timerStandard.Tick
        If (radioButtonSystem.Checked) Then
            lblIdleTime.Text = "Idle Time(ms): " + IdleTimer.GetSystemIdleTime().ToString()
        Else
            lblIdleTime.Text = "Idle Time(ms): " + cmpApplicationIdleTimer.GetApplicationIdleTime().ToString()
        End If
    End Sub

    Private Sub Form1_Closed(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Closed
        If Not (cmpIdleTimer Is Nothing) Then
            cmpIdleTimer.Enabled = False
        End If
        If Not (cmpApplicationIdleTimer Is Nothing) Then
            cmpApplicationIdleTimer.Enabled = False
        End If
        timerStandard.Enabled = False
    End Sub

    Private Sub cmpIdleTimer_Idle(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmpIdleTimer.Idle
        Set_textBoxOutText(textBoxOut.Text & DateTime.Now.Hour.ToString() & ":" &
            DateTime.Now.Minute.ToString() & ":" &
         DateTime.Now.Second.ToString() & ":" & DateTime.Now.Millisecond.ToString() &
         " - Idle Fired." & Environment.NewLine)
    End Sub

    Private Sub cmpIdleTimer_Resume(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmpIdleTimer.[Resume], cmpIdleTimer.Resume
        Set_textBoxOutText(textBoxOut.Text & DateTime.Now.Hour.ToString() & ":" &
            DateTime.Now.Minute.ToString() & ":" &
         DateTime.Now.Second.ToString() & ":" & DateTime.Now.Millisecond.ToString() &
         " - Resume Fired." & Environment.NewLine)
    End Sub

    Private Sub cmpIdleTimer_IdleWarning(sender As Object, e As EventArgs) Handles cmpIdleTimer.IdleWarning
        Set_textBoxOutText(textBoxOut.Text & DateTime.Now.Hour.ToString() & ":" &
            DateTime.Now.Minute.ToString() & ":" &
         DateTime.Now.Second.ToString() & ":" & DateTime.Now.Millisecond.ToString() &
         " - Warning Fired." & Environment.NewLine)
    End Sub

    Private Sub cmpApplicationIdleTimer_Idle(sender As Object, e As EventArgs) Handles cmpApplicationIdleTimer.Idle
        Set_textBoxOutText(textBoxOut.Text & DateTime.Now.Hour.ToString() & ":" &
            DateTime.Now.Minute.ToString() & ":" &
         DateTime.Now.Second.ToString() & ":" & DateTime.Now.Millisecond.ToString() &
         " - Idle Fired." & Environment.NewLine)
    End Sub

    Private Sub cmpApplicationIdleTimer_IdleWarning(sender As Object, e As EventArgs) Handles cmpApplicationIdleTimer.IdleWarning
        Set_textBoxOutText(textBoxOut.Text & DateTime.Now.Hour.ToString() & ":" &
            DateTime.Now.Minute.ToString() & ":" &
         DateTime.Now.Second.ToString() & ":" & DateTime.Now.Millisecond.ToString() &
         " - Warning Fired." & Environment.NewLine)
    End Sub

    Private Sub cmpApplicationIdleTimer_Resume(sender As Object, e As EventArgs) Handles cmpApplicationIdleTimer.Resume
        Set_textBoxOutText(textBoxOut.Text & DateTime.Now.Hour.ToString() & ":" &
            DateTime.Now.Minute.ToString() & ":" &
         DateTime.Now.Second.ToString() & ":" & DateTime.Now.Millisecond.ToString() &
         " - Resume Fired." & Environment.NewLine)
    End Sub
End Class
