using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using ZylSoft.Timers;

namespace TimerResolutionDemo
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button btnStart;
		private System.Windows.Forms.Button btnStop;
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.TextBox textBoxOut;
		private System.Windows.Forms.Timer timerStandard;
        private System.Windows.Forms.Label lblIdleTime;
        private WinFormsApplicationIdleTimer applicationIdleTimer;
        private RadioButton radioButtonSystem;
        private RadioButton radioButtonApplication;
        private IdleTimer idleTimer;

        // This delegate enables asynchronous calls for setting
        // the text property on a TextBox control.
        delegate void SetTextCallback(string text);        

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//		
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            this.textBoxOut = new System.Windows.Forms.TextBox();
            this.btnStart = new System.Windows.Forms.Button();
            this.btnStop = new System.Windows.Forms.Button();
            this.timerStandard = new System.Windows.Forms.Timer(this.components);
            this.lblIdleTime = new System.Windows.Forms.Label();
            this.radioButtonSystem = new System.Windows.Forms.RadioButton();
            this.radioButtonApplication = new System.Windows.Forms.RadioButton();
            this.idleTimer = new ZylSoft.Timers.IdleTimer(this.components);
            this.applicationIdleTimer = new ZylSoft.Timers.WinFormsApplicationIdleTimer(this.components);
            this.SuspendLayout();
            // 
            // textBoxOut
            // 
            this.textBoxOut.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
            | System.Windows.Forms.AnchorStyles.Left) 
            | System.Windows.Forms.AnchorStyles.Right)));
            this.textBoxOut.Location = new System.Drawing.Point(19, 20);
            this.textBoxOut.Multiline = true;
            this.textBoxOut.Name = "textBoxOut";
            this.textBoxOut.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
            this.textBoxOut.Size = new System.Drawing.Size(338, 138);
            this.textBoxOut.TabIndex = 0;
            // 
            // btnStart
            // 
            this.btnStart.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.btnStart.Location = new System.Drawing.Point(136, 199);
            this.btnStart.Name = "btnStart";
            this.btnStart.Size = new System.Drawing.Size(90, 29);
            this.btnStart.TabIndex = 1;
            this.btnStart.Text = "Start";
            this.btnStart.Click += new System.EventHandler(this.btnStart_Click);
            // 
            // btnStop
            // 
            this.btnStop.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.btnStop.Location = new System.Drawing.Point(136, 235);
            this.btnStop.Name = "btnStop";
            this.btnStop.Size = new System.Drawing.Size(90, 28);
            this.btnStop.TabIndex = 2;
            this.btnStop.Text = "Stop";
            this.btnStop.Click += new System.EventHandler(this.btnStop_Click);
            // 
            // timerStandard
            // 
            this.timerStandard.Interval = 200;
            this.timerStandard.Tick += new System.EventHandler(this.timerStandard_Tick);
            // 
            // lblIdleTime
            // 
            this.lblIdleTime.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
            this.lblIdleTime.AutoSize = true;
            this.lblIdleTime.Location = new System.Drawing.Point(19, 171);
            this.lblIdleTime.Name = "lblIdleTime";
            this.lblIdleTime.Size = new System.Drawing.Size(61, 15);
            this.lblIdleTime.TabIndex = 3;
            this.lblIdleTime.Text = "Idle Time: ";
            // 
            // radioButtonSystem
            // 
            this.radioButtonSystem.AutoSize = true;
            this.radioButtonSystem.Checked = true;
            this.radioButtonSystem.Location = new System.Drawing.Point(19, 204);
            this.radioButtonSystem.Name = "radioButtonSystem";
            this.radioButtonSystem.Size = new System.Drawing.Size(63, 19);
            this.radioButtonSystem.TabIndex = 4;
            this.radioButtonSystem.TabStop = true;
            this.radioButtonSystem.Text = "System";
            this.radioButtonSystem.UseVisualStyleBackColor = true;
            // 
            // radioButtonApplication
            // 
            this.radioButtonApplication.AutoSize = true;
            this.radioButtonApplication.Location = new System.Drawing.Point(19, 229);
            this.radioButtonApplication.Name = "radioButtonApplication";
            this.radioButtonApplication.Size = new System.Drawing.Size(86, 19);
            this.radioButtonApplication.TabIndex = 5;
            this.radioButtonApplication.Text = "Application";
            this.radioButtonApplication.UseVisualStyleBackColor = true;
            // 
            // idleTimer
            // 
            this.idleTimer.Enabled = false;
            this.idleTimer.IdleInterval = 8000;
            this.idleTimer.IdleIntervalInMinutes = 0.13333333333333333D;
            this.idleTimer.IdleIntervalInSeconds = 8D;
            this.idleTimer.WarningInterval = 6000;
            this.idleTimer.WarningIntervalInMinutes = 0.1D;
            this.idleTimer.WarningIntervalInSeconds = 6D;
            this.idleTimer.Idle += new System.EventHandler<System.EventArgs>(this.idleTimer_Idle);
            this.idleTimer.Resume += new System.EventHandler<System.EventArgs>(this.idleTimer_Resume);
            this.idleTimer.IdleWarning += new System.EventHandler<System.EventArgs>(this.idleTimer_IdleWarning);
            // 
            // applicationIdleTimer
            // 
            this.applicationIdleTimer.Enabled = false;
            this.applicationIdleTimer.IdleInterval = 8000;
            this.applicationIdleTimer.IdleIntervalInMinutes = 0.13333333333333333D;
            this.applicationIdleTimer.IdleIntervalInSeconds = 8D;
            this.applicationIdleTimer.WarningInterval = 6000;
            this.applicationIdleTimer.WarningIntervalInMinutes = 0.1D;
            this.applicationIdleTimer.WarningIntervalInSeconds = 6D;
            this.applicationIdleTimer.Idle += new System.EventHandler<System.EventArgs>(this.idleTimer_Idle);
            this.applicationIdleTimer.Resume += new System.EventHandler<System.EventArgs>(this.idleTimer_Resume);
            this.applicationIdleTimer.IdleWarning += new System.EventHandler<System.EventArgs>(this.idleTimer_IdleWarning);
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(6, 16);
            this.ClientSize = new System.Drawing.Size(371, 276);
            this.Controls.Add(this.radioButtonApplication);
            this.Controls.Add(this.radioButtonSystem);
            this.Controls.Add(this.lblIdleTime);
            this.Controls.Add(this.btnStop);
            this.Controls.Add(this.btnStart);
            this.Controls.Add(this.textBoxOut);
            this.KeyPreview = true;
            this.Name = "Form1";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "ZylIdleTimer.NET Demo";
            this.Closed += new System.EventHandler(this.Form1_Closed);
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

        private void Set_textBoxOut(string text)
        {
            // InvokeRequired required compares the thread ID of the
            // calling thread to the thread ID of the creating thread.
            // If these threads are different, it returns true.
            if (this.textBoxOut.InvokeRequired)
            {
                SetTextCallback d = new SetTextCallback(Set_textBoxOut);
                this.Invoke(d, new object[] { text });
            }
            else
            {
                this.textBoxOut.Text = text;
                this.textBoxOut.SelectionStart = textBoxOut.Text.Length;
                this.textBoxOut.SelectionLength = 0;
                this.textBoxOut.ScrollToCaret();
            }
        }

		private void btnStart_Click(object sender, System.EventArgs e)
		{
			timerStandard.Enabled = true;
            if (radioButtonSystem.Checked)
            {
                idleTimer.Enabled = true;
                applicationIdleTimer.Enabled = false;
            }
            else
            {
                applicationIdleTimer.Enabled = true;
                idleTimer.Enabled = false;
            }
            radioButtonSystem.Enabled = false;
            radioButtonApplication.Enabled = false;
        }

		private void btnStop_Click(object sender, System.EventArgs e)
		{
			timerStandard.Enabled = false;
			idleTimer.Enabled = false;
            applicationIdleTimer.Enabled = false;
            radioButtonSystem.Enabled = true;
            radioButtonApplication.Enabled = true;

        }	
	
		private void Form1_Closed(object sender, System.EventArgs e)
		{
			if (idleTimer != null)
			{
				idleTimer.Enabled = false;				
			}

            if (applicationIdleTimer != null)
                applicationIdleTimer.Enabled = false;

            if (timerStandard != null)
                timerStandard.Enabled = false;
        }

		private void timerStandard_Tick(object sender, System.EventArgs e)
		{
            if (radioButtonSystem.Checked)
			    lblIdleTime.Text = "Idle Time(ms): " + IdleTimer.GetSystemIdleTime().ToString();
            else
                lblIdleTime.Text = "Idle Time(ms): " + applicationIdleTimer.GetApplicationIdleTime().ToString();
        }

		private void idleTimer_Idle(object sender, System.EventArgs e)
		{
			Set_textBoxOut(textBoxOut.Text + DateTime.Now.Hour.ToString() + ":" + DateTime.Now.Minute.ToString() + ":"  +
				DateTime.Now.Second.ToString() + ":" +  DateTime.Now.Millisecond.ToString() +
				" - Idle Fired." + Environment.NewLine);                  
        }

        private void idleTimer_Resume(object sender, EventArgs e)
        {
            Set_textBoxOut(textBoxOut.Text + DateTime.Now.Hour.ToString() + ":" + DateTime.Now.Minute.ToString() + ":" +
                DateTime.Now.Second.ToString() + ":" + DateTime.Now.Millisecond.ToString() +
                " - Resume Fired." + Environment.NewLine);	
        }

        private void idleTimer_IdleWarning(object sender, EventArgs e)
        {
            Set_textBoxOut(textBoxOut.Text + DateTime.Now.Hour.ToString() + ":" + DateTime.Now.Minute.ToString() + ":" +
                DateTime.Now.Second.ToString() + ":" + DateTime.Now.Millisecond.ToString() +
                " - Warning Fired." + Environment.NewLine);
        }       
    }
}
